Subject: Re: [PATCH 1/3] [ethtool] Add support for RX packet classification in a network device

From: [email-masked]
Date: Mon, 09 Feb 2009 19:17:09 -0800

On 02/ 9/09 06:03 PM, David Miller wrote:
> From: [email-masked]
> Date: Mon, 09 Feb 2009 15:12:21 -0800
> 
>> +struct ethtool_tcpip4_spec {
>> +	__u32	ip4src;
>> +	__u32	ip4dst;
>> +	__u16	psrc;
>> +	__u16	pdst;
>> +	__u8    tos;
>> +};
> 
> The IP addresses and ports in these new interfaces, are
> they to be specified in network or cpu byte order?

The interfaces assumes that they are to be specified in network order. I 
will add a comment to mention that.

Looking back at my ethtool(8) patch, I have a bug in the code where I do 
not do this translation for the ports and spi (I got it right for the IP 
addresses). I will fix this and repost all the patches.

Thanks for raising this.

--santwona

> 
> That's usually the first thing a person will wonder when
> trying to use to implement support for these interfaces.
> 
> My guess is that the specification is cpu endianness,
> however note that this flies in the face with how this
> is handled in pretty much every other networking interface
> in the kernel.  The standard is to use network endianness
> when passing ports and IP addressing information into the
> kernel.
> 
> I wouldn't reject this patch series just for this reason,
> in fact I'm ready to apply this stuff, but just thought I'd
> mention it just in case you hadn't considered the issue
> yourself.